﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=11.2
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim timer1 As Timer
	
	Public SharedFolder As String
	Private LifeOfGateway As String=""
	Public  ReadJsonList As List
	Public ParamMap As Map
	Private DelayStartAnalyze As Int= 35
	Private TimeAutoChange As Int=0
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	SharedFolder ="/storage/emulated/0/Android/data/HH.Gateway/files"
		
	timer1.Initialize("timer1", 10000) 'Timer 10s
	timer1.Enabled=True
	
	Try
		If File.Exists(File.DirDefaultExternal,"ConfLocal.json")=False Then
			File.Copy(SharedFolder,"ConfLocal.json",File.DirDefaultExternal,"ConfLocal.json")
			Log("Copie du fichier ConfLocal")
		End If
	Catch
		Log(LastException)
	End Try
		
	
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
End Sub

Sub Timer1_Tick
	
	Try
		If File.Exists(File.DirDefaultExternal,"ConfLocal.json") Then
			wait for (Read_JSONfileParameter("ConfLocal.json")) complete  (resultConfLocal As Boolean)
			If DelayStartAnalyze<>0 Then
				Log("Chargement des pamamètres")
				DelayStartAnalyze= ParamMap.Get("DelayStartAnalyze")
				TimeAutoChange= ParamMap.Get("TimeAutoChange")
			End If
			
		End If
	Catch
		Log(LastException)
	End Try
	TimeZone
	ReadFile
	
End Sub

Sub ReadFile
	
	Dim reader As TextReader
	Dim list_read As List
	list_read.Initialize
	list_read.Clear
	timer1.Enabled=False
	DateTime.DateFormat="dd MMM yyyy HH:mm:ss"
	
	Private delay As Long=DateTime.Now+(30*1000) 'TimeOut de 30s
	
	Try
	
		Do While File.Exists(SharedFolder, "Life.txt")=False And DateTime.Now < delay 
			Sleep(0)
		Loop
		
	
		If File.Exists(SharedFolder, "Life.txt")=True Then
			reader.Initialize(File.Openinput(SharedFolder, "Life.txt"))
			list_read=reader.ReadList
			reader.Close
		End If
		
	Catch
		Log("Lecture du fichier de vie impossible")
	End Try
	
	
	Try
		If list_read.Size=1 Then
			LifeOfGateway=list_read.Get(0)
			Private targetDate As Long = DateTime.DateParse(list_read.Get(0))
			
			If targetDate> DateTime.Now-((DelayStartAnalyze*3)*60000) Then 'délai de 35mn (par défaut) ou valeur confLocal max pour définir une vie Ko
				Log("Application active :-) " & list_read.Get(0))
			Else
				Log("Application inactive !!! " & list_read.Get(0))
				File.Delete(SharedFolder, "Life.txt")
				writeLog
				StartAppli
				
			End If
		Else
			Log("Application ne semble pas redémarrer !!! ")
			writeLog
			StartAppli
			
		End If
	Catch
		Log(LastException)
	End Try
	
	Endservce
End Sub

Sub Read_JSONfileParameter(file_name As String) As ResumableSub
	
	Dim JSON As JSONParser
	ParamMap.Initialize
	Try
		JSON.Initialize(File.ReadString(File.DirDefaultExternal, file_name))
		
		ParamMap = JSON.NextObject
		Return True
	Catch
		Log(LastException)
		Return False
	End Try
	
		
End Sub

Sub StartAppli 
	
	Dim in As Intent
	Dim pm As PackageManager
	'in.Initialize("","")
	
	Try
		in = pm.GetApplicationIntent("HH.Gateway")
		If in.IsInitialized Then StartActivity(in)
		
		Log("Restart appli")
		
	Catch
		Log(LastException)
		
	End Try
	
	
End Sub

Sub writeLog
	
	Dim Writer As TextWriter
		
	Writer.Initialize(File.OpenOutput(File.DirDefaultExternal, "LogMonotor.txt",True))
	DateTime.DateFormat="dd MMM yyyy HH:mm:ss"
	
	Try
		Writer.WriteLine(DateTime.Date(DateTime.Now))
		Writer.WriteLine("Redémarrage de la Gateway arrêtée le " & LifeOfGateway)
		'Writer.WriteLine(DateTime.Time(DateTime.Now))
		Writer.Close
	Catch
		
	End Try
End Sub

Sub TimeZone
	
	'************** Gestion changement d'heure automatique **************
	DateTime.SetTimeZone(0)
	
	Try
		If TimeAutoChange=0 Then 'Changement auto
			Log(">>>>>>>>> Chagement d'heure auto")
			If DateTime.GetMonth(DateTime.Now)=10 Then 'Mois d'octobre
				'DateTime.SetTimeZone(2)
				If DateTime.GetDayOfMonth(DateTime.Now)>23 And DateTime.GetDayOfMonth(DateTime.Now)<=31 Then
					Private datestart As String = "23.10." & DateTime.GetYear(DateTime.Now)
					Private DateParse As Long = DateTime.DateParse(datestart)
					For ii1= 24 To DateTime.GetDayOfMonth(DateTime.Now) ' Recherche si le dernier dimanche du mois d'octobre est passé, et si oui, passe en heure d'hiver
						Private dateIndex As Long= DateTime.Add(DateParse,0,0,1)
						If DateTime.GetDayOfWeek(dateIndex)=1  Then 'Si le jour est dimanche
							If ii1= DateTime.GetDayOfMonth(DateTime.Now) Then 'si le jour est aujourd'hui
								If DateTime.Time(DateTime.Now)>= DateTime.TimeParse("03:00:00") Then
									DateTime.SetTimeZone(1)
								End If
							Else
								DateTime.SetTimeZone(1)
							End If
							Exit
						End If
						DateParse=dateIndex
					Next
				End If
					
			Else If DateTime.GetMonth(DateTime.Now)=3 Then 'Mois de Mars
				'DateTime.SetTimeZone(1)
				If DateTime.GetDayOfMonth(DateTime.Now)>22 And DateTime.GetDayOfMonth(DateTime.Now)<=30 Then
					Private datestart As String = "22.03." & DateTime.GetYear(DateTime.Now)
					Private DateParse As Long = DateTime.DateParse(datestart)
					For ii1= 23 To DateTime.GetDayOfMonth(DateTime.Now) ' Recherche si le dernier dimanche du mois de mars est passé, et si oui, passe en heure d'été
						Private dateIndex As Long= DateTime.Add(DateParse,0,0,1)
						If DateTime.GetDayOfWeek(dateIndex)=1  Then 'Si le jour est dimanche
							If ii1= DateTime.GetDayOfMonth(DateTime.Now) Then 'si le jour est aujourd'hui
								If DateTime.Time(DateTime.Now)>= DateTime.TimeParse("02:00:00") Then
									DateTime.SetTimeZone(2)
								End If
							Else
								DateTime.SetTimeZone(2)
							End If
							Exit
						End If
						DateParse=dateIndex
					Next
				End If
			Else If DateTime.GetMonth(DateTime.Now)>10 Or DateTime.GetMonth(DateTime.Now)<3 Then
				DateTime.SetTimeZone(1)
			Else If DateTime.GetMonth(DateTime.Now)>3 Or DateTime.GetMonth(DateTime.Now)<10 Then
				DateTime.SetTimeZone(2)
			End If
		Else 'Changement défini dans les paramètres
			DateTime.SetTimeZone(TimeAutoChange)
		End If
		Log("<<<<<<<<<<<<<<<<<  Heure UTC + " & DateTime.TimeZoneOffset & "H >>>>>>>>>>>>>>>>")
	Catch
		Log(LastException)
	End Try
	
	
	
End Sub

Sub Endservce
	'StartServiceAt(Me,DateTime.Now + 10000,True)
	Service.StopAutomaticForeground
	StopService(Me)
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
	
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
	StartServiceAt(Me,DateTime.Now + 10000,True)
End Sub
